

import { EventTouch, Node, Toggle, Tween, Vec3, _decorator, easing, tween } from "cc";
import { oops } from "../../../../../extensions/oops-plugin-framework/assets/core/Oops";
import { ecs } from "../../../../../extensions/oops-plugin-framework/assets/libs/ecs/ECS";
import { CCComp } from "../../../../../extensions/oops-plugin-framework/assets/module/common/CCComp";
import { UIID } from "../../common/config/GameUIConfig";
import { SingletonModuleComp } from "../../common/SingletonModuleComp";
import { AdManager } from "../../../platform/ad/AdManager";
import { ClearCellOperationComp } from "../bll/ClearCellOperation";


const { ccclass, property } = _decorator;

/** 角色信息界面 */
@ccclass('CheckpointClearViewComp')
@ecs.register('CheckpointClearView', false)
export class CheckpointClearViewComp extends CCComp {

    private btnClose
    private btnGiveup
    private btnGet

    onAdded(args: any) {
        console.log(args);
    }

    onLoad() {
        this.btnClose = this.node.getChildByPath("BG/btn_close")
        this.btnGiveup = this.node.getChildByPath("BG/btn_giveup")
        this.btnGet = this.node.getChildByPath("BG/btn_get")
        this.btnClose.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.btnGiveup.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);
        this.btnGet.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);

        const window = this.node.getChildByName("BG")
        window.setScale(new Vec3(0, 0, 1));
        // 使用Tween来实现动画效果
        Tween.stopAllByTarget(window); // 停止该节点上的所有其他Tween
        tween(window)
            // .delay(0.1)
            .to(0.3, { scale: new Vec3(0.5, 0.5, 1) }, { easing: easing.backOut }) // 缩放动画
            .start(); // 开始动画
    }

    private onTouchEnd(event: EventTouch) {
        switch (event.target.name) {
            case "btn_close":
                oops.gui.remove(UIID.ClearCell);
                break;
            case "btn_giveup":
                oops.gui.remove(UIID.ClearCell);
                break;
            case "btn_get":
                const checkpoint = ecs.getSingleton(SingletonModuleComp).account.checkpoint
                if (checkpoint.CheckpointModelBase.vm.clearCount >= 3) {
                    oops.gui.toast('该关卡使用次数已满')
                    oops.gui.remove(UIID.ClearCell);
                    return
                }
                // ecs.getSingleton(SingletonModuleComp).account.checkpoint.add(ClearCellOperationComp)
                // ecs.getSingleton(SingletonModuleComp).account.checkpoint.CheckpointModelBase.vm.clearCount+=1
                AdManager.getInstance().showRewardVideoAd(()=>{
                    console.log('成功看完广告')
                    ecs.getSingleton(SingletonModuleComp).account.checkpoint.add(ClearCellOperationComp)
                    ecs.getSingleton(SingletonModuleComp).account.checkpoint.CheckpointModelBase.vm.clearCount+=1
                    oops.gui.remove(UIID.ClearCell);
                })
                break;
        }

        event.propagationStopped = true;
    }

    reset() {
        this.node.destroy();
    }
}